<?php
namespace Teknisa\CMP\Factories;

use \Zeedhi\Framework\DataSource\DataSet;
use \Zeedhi\Framework\DTO;
use \Zeedhi\Framework\DB\StoredProcedure\StoredProcedure;
use \Zeedhi\Framework\DB\StoredProcedure\Param;

class Cmp99000GeracaoAfPrevisaoFactory
{
  
  protected $entityManager;
  protected $connection;
    
  public function __construct($entityManager, $environment) {
    $this->entityManager  = $entityManager;
    $this->connection     = $entityManager->getConnection();
    $this->environment    = $environment;
  }
   

    public function realizaCommit(){
       $this->connection->commit();
    }

    public function realizaRollback(){
        $this->connection->rollBack();
    }
    
    public function beginTransaction(){
        $this->entityManager->beginTransaction();
    }

    private function executeQuery($sql, $params){
        
        $this->entityManager->beginTransaction();
      
        $std = $this->connection->prepare($sql);
     
        $std->execute($params);

        return $std;
    }

    public function getItmaPurPrecData($row){
      try {
           $sql = "SELECT ID,CDFORNECED,NRAPURPREC,IDCHECK,CDFILSOLI,NMFILIAL,DSFILIALC, DSFILIAL,CDFILLAN,NRSOLICMP,CDPRODUTO,DTPROGENTR,QTSOLIPROD,NMPRODUTO,CDARVPROD,SGUNIDADE,DSPRODUTO,CDMARCA,NMMARCA,DSMARCA,VRCUSTO,VRPRECUNIAP,NRORG,QTDIAESTOQUE,QTCONSUMODIA,QTESTOQUE,QTDURACAEST,QTCONSUMODIASEST,QTITEMPED,QTPROGENTAF,QTENTRADAS,QTSAIDAS,VRCUSTOTOTAL,NRINSJURFORN,NMFANTFORN,CDEXPRODFORN
FROM (
SELECT
 CDCENTITMAP||NRSEQITMAP||CDREGITMAP||CDFORNITMAP||NRCOLEITMAP||TO_CHAR(DTENTRAPUT, 'DD/MM/YYYY')||CDFILIAP||CDPRODITMAP||CDMARCITMAP ID, 
ITMAPURPREC.CDFORNITMAP AS CDFORNECED,
 ITMAPURPREC.NRSEQITMAP 
 AS NRAPURPREC,
 'U' 
 AS IDCHECK,
 FILIAL.CDFILIAL CDFILSOLI,
 FILIAL.NMFILIAL,
 FILIAL.CDFILIAL
 || ' - '
 || FILIAL.NMFILIAL || ' - COMPRAR' DSFILIALC,
 FILIAL.CDFILIAL
 || ' - '
 || FILIAL.NMFILIAL DSFILIAL,
 ITMAPURPREC.CDCENTITMAP CDFILLAN,
 NRSEQITMAP 
 NRSOLICMP,
 PRODUTO.CDPRODUTO,
 DTENTRAPUT 
 DTPROGENTR,
 QTACOMP 
 QTSOLIPROD,
 PRODUTO.NMPRODUTO,
 PRODUTO.CDARVPROD,
 PRODUTO.SGUNIDADE,
 PRODUTO.CDARVPROD
 || ' - '
 || PRODUTO.NMPRODUTO 
 DSPRODUTO,
 MARCA.CDMARCA,
 MARCA.NMMARCA,
 MARCA.CDMARCA
 || ' - '
 || MARCA.NMMARCA 
 DSMARCA,
 ITMAPURPREC.VRPRECUNIAP 
 VRCUSTO,
 ITMAPURPREC.VRPRECUNIAP*1.1 VRPRECUNIAP, 
 ITMAPURPREC.NRORG,
 APURPRECO.QTDIAESTOQUE,
 ITMAPURPREC.QTCONSUMODIA,
 ITMAPURPREC.QTESTOQUE,
 
ITMAPURPREC.QTDURACAEST,
 ITMAPURPREC.QTCONSUMODIASEST,
 ITMAPURPREC.QTITEMPED,
 ITMAPURPREC.QTPROGENTAF,
 ITMAPURPREC.QTENTRADAS,
 
ITMAPURPREC.QTSAIDAS,
 ITMAPURPREC.QTACOMP * VRPRECUNIAP VRCUSTOTOTAL,
 
FORNECEDOR.NRINSJURFORN,
 FORNECEDOR.NMFANTFORN,
 ITMAPURPREC.CDEXPRODFORN
FROM
 ITMAPURPREC,
 PRODUTO,
 FILIAL,
 MARCA,
 APURPRECO,
 
FORNECEDOR
WHERE
 ITMAPURPREC.CDCENTITMAP = APURPRECO.CDFILCENTCMP
 AND ITMAPURPREC.NRSEQITMAP = APURPRECO.NRAPURPREC
 AND 
ITMAPURPREC.CDCENTITMAP = :CDFILCENTCMP
AND ( INSTR('_G_C_', :TIPOTELA) > 0 ) 
AND ( ( INSTR(:CDFORNECED, ITMAPURPREC.CDFORNITMAP) > 0 ) OR ( :CDFORNECED = 'T' ) ) 
 AND ITMAPURPREC.NRSEQITMAP = :NRAPURPREC
 AND ITMAPURPREC.CDFILIAP = FILIAL.CDFILIAL
 AND 
ITMAPURPREC.CDPRODITMAP = PRODUTO.CDPRODUTO
 AND ITMAPURPREC.CDMARCITMAP = MARCA.CDMARCA
 AND ( ( INSTR(:CDMARCA, ITMAPURPREC.CDMARCITMAP) > 0 )
 OR ( :CDMARCA = 'T' ) )
 AND ( ( INSTR(:CDFILIAL, FILIAL.CDFILIAL) > 0 )
 OR ( :CDFILIAL = 'T' ) )
 AND ( ( PRODUTO.CDARVPROD 
BETWEEN :CDPRODINI AND RPAD(:CDPRODFIN, 20, 'Z') )
 AND ITMAPURPREC.CDFORNITMAP = FORNECEDOR.CDFORNECED
 OR ( :CDPRODFIN = 'T' ) )
 
 AND NOT EXISTS (
 SELECT
 1
 FROM
 AUTOFORNE,
 ITEMAUTF I,
 PRODUTO P
 WHERE
 
 I.CDFILDEST = AUTOFORNE.CDFILDEST
 AND I.CDFILLANC = AUTOFORNE.CDFILLANC
 AND I.NRAUTOFORN = AUTOFORNE.NRAUTOFORN
 
 AND I.CDFILDEST = ITMAPURPREC.CDFILIAP
 AND I.DTENTRITMSOL = ITMAPURPREC.DTENTRAPUT
 AND I.CDPRODUTO = P.CDPRODUTO
 
AND PRODUTO.CDPRODESTO = P.CDPRODESTO
 AND AUTOFORNE.NRSEQAPURAF = ITMAPURPREC.NRSEQITMAP
 AND AUTOFORNE.CDFORNECED = 
ITMAPURPREC.CDFORNITMAP
 )
UNION 
SELECT
 CDCENTITMAP||NRSEQITMAP||CDREGITMAP||CDFORNITMAP||NRCOLEITMAP||TO_CHAR(DTENTRAPUT, 'DD/MM/YYYY')||CDFILIAP||CDPRODITMAP||CDMARCITMAP ID, 
ITMAPURPREC.CDFORNITMAP AS CDFORNECED,
 ITMAPURPREC.NRSEQITMAP 
 AS NRAPURPREC,
 'U' 
 AS IDCHECK,
 FILIAL.CDFILIAL CDFILSOLI,
FILIAL.NMFILIAL,
 FILIAL.CDFILIAL
 || ' - '
 || FILIAL.NMFILIAL || ' - ESTOQUE' 
DSFILIALC,
 FILIAL.CDFILIAL
 || ' - '
 || FILIAL.NMFILIAL DSFILIAL,
 ITMAPURPREC.CDCENTITMAP CDFILLAN,
 NRSEQITMAP 
 NRSOLICMP,
 PRODUTO.CDPRODUTO,
 DTENTRAPUT 
 DTPROGENTR,
 ITMAPURPREC.QTESTOQUE QTSOLIPROD,
 PRODUTO.NMPRODUTO,
 PRODUTO.CDARVPROD,
 PRODUTO.SGUNIDADE,
 PRODUTO.CDARVPROD
 || ' - '
 || PRODUTO.NMPRODUTO 
 DSPRODUTO,
 MARCA.CDMARCA,
 MARCA.NMMARCA,
 MARCA.CDMARCA
 || ' - '
 || MARCA.NMMARCA 
 DSMARCA,
 ITMAPURPREC.VRPRECUNIAP 
 VRCUSTO,
 ITMAPURPREC.VRPRECUNIAP*1.1 VRPRECUNIAP, 
 ITMAPURPREC.NRORG,
 APURPRECO.QTDIAESTOQUE,
 ITMAPURPREC.QTCONSUMODIA,
 ITMAPURPREC.QTESTOQUE,
 
ITMAPURPREC.QTDURACAEST,
 ITMAPURPREC.QTCONSUMODIASEST,
 ITMAPURPREC.QTITEMPED,
 ITMAPURPREC.QTPROGENTAF,
 ITMAPURPREC.QTENTRADAS,
 
ITMAPURPREC.QTSAIDAS,
 ITMAPURPREC.QTACOMP * VRPRECUNIAP VRCUSTOTOTAL,
 
FORNECEDOR.NRINSJURFORN,
 FORNECEDOR.NMFANTFORN,
 ITMAPURPREC.CDEXPRODFORN
FROM
 ITMAPURPREC,
 PRODUTO,
 FILIAL,
 MARCA,
 APURPRECO,
 
FORNECEDOR
WHERE
 ITMAPURPREC.CDCENTITMAP = APURPRECO.CDFILCENTCMP
 AND ITMAPURPREC.NRSEQITMAP = APURPRECO.NRAPURPREC
 AND 
ITMAPURPREC.CDCENTITMAP = :CDFILCENTCMP
AND ( INSTR('_C_', :TIPOTELA) > 0 )
AND ( ( INSTR(:CDFORNECED, ITMAPURPREC.CDFORNITMAP) > 0 ) OR ( :CDFORNECED = 'T' ) ) 
 AND ITMAPURPREC.NRSEQITMAP = :NRAPURPREC
 AND ITMAPURPREC.CDFILIAP = FILIAL.CDFILIAL
 AND 
ITMAPURPREC.CDPRODITMAP = PRODUTO.CDPRODUTO
 AND ITMAPURPREC.CDMARCITMAP = MARCA.CDMARCA
 AND ( ( INSTR(:CDMARCA, ITMAPURPREC.CDMARCITMAP) > 0 )
 OR ( :CDMARCA = 'T' ) )
 AND ( ( INSTR(:CDFILIAL, FILIAL.CDFILIAL) > 0 )
 OR ( :CDFILIAL = 'T' ) )
 AND ( ( PRODUTO.CDARVPROD 
BETWEEN :CDPRODINI AND RPAD(:CDPRODFIN, 20, 'Z') )
 AND ITMAPURPREC.CDFORNITMAP = FORNECEDOR.CDFORNECED
 OR ( :CDPRODFIN = 'T' ) )
 
 AND NOT EXISTS (
 SELECT
 1
 FROM
 AUTOFORNE,
 ITEMAUTF I,
 PRODUTO P
 WHERE
 
 I.CDFILDEST = AUTOFORNE.CDFILDEST
 AND I.CDFILLANC = AUTOFORNE.CDFILLANC
 AND I.NRAUTOFORN = AUTOFORNE.NRAUTOFORN
 
 AND I.CDFILDEST = ITMAPURPREC.CDFILIAP
 AND I.DTENTRITMSOL = ITMAPURPREC.DTENTRAPUT
 AND I.CDPRODUTO = P.CDPRODUTO
 
AND PRODUTO.CDPRODESTO = P.CDPRODESTO
 AND AUTOFORNE.NRSEQAPURAF = ITMAPURPREC.NRSEQITMAP
 AND AUTOFORNE.CDFORNECED = 
ITMAPURPREC.CDFORNITMAP 
 ))
ORDER BY
 DSFILIAL DESC,
 CDARVPROD, 
 CDMARCA";

            $params = [
                //"CDFORNERELACAF" => $row["CDFORNERELACAF"] ?? null,
               "CDFORNECED" => $row["CDFORNECED"] ?? null,
               "CDFILIAL" => $row["CDFILIAL"],
               // "CDCOMPRADOR" => $row["CDCOMPRADOR"],
               // "TIPOPREVISAO" => $row["TIPOPREVISAO"],
               // "CDSUBGRUPPROD" => $row["CDSUBGRUPPROD"][0] ?? null,
                "CDPRODINI" => $row["CDPRODINI"],
                "CDPRODFIN" => $row["CDPRODFIN"],
                "CDMARCA" => $row["CDMARCA"],
               // "DTNICIAL" => $row["DTNICIAL"],
               // "QTDIAESTOQUE" => $row["QTDIAESTOQUE"],
               // "DTENTREGA" => $row["DTENTREGA"] ,
               // "CDTIPOCUSTO" => $row["CDTIPOCUSTO"],
                "NRAPURPREC" => $row["NRAPURPREC"] ?? null,
                "CDFILCENTCMP" => $row["CDFILCENTCMP"] ?? null,
                "TIPOTELA" => $row["TIPOTELA"]
            ];
            
            $std = $this->executeQuery($sql, $params);
            return $std->fetchAll();
        } catch (\Exception $e) {
            throw $e;
        }
    }

    public function gerarProcedure($params){
        try{
            $rowsAffect = "";
            $procedure  = new StoredProcedure($this->connection, 'GERA_AF_POR_PREVISAO_COMPRA');

            $procedure->addParam(new Param('P_CDFILCENTCMP', Param::PARAM_INPUT, isset($params['CDFILCENTCMP']) ? $params['CDFILCENTCMP']: null, Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_NRAPURPREC', Param::PARAM_INPUT, isset($params['NRAPURPREC']) ? $params['NRAPURPREC'] : null, Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_CDFORNERELACAF', Param::PARAM_INPUT, isset($params['CDFORNERELACAF']) ? $params['CDFORNERELACAF'] :  null, Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_CDFORNECED', Param::PARAM_INPUT, isset($params['CDFORNECED']) ? $params['CDFORNECED'] : null, Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_CDFILIAL', Param::PARAM_INPUT, isset($params['CDFILIAL']) ? $params['CDFILIAL'] : null, Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_CDCOMPRADOR', Param::PARAM_INPUT, isset($params['CDCOMPRADOR']) ? $params['CDCOMPRADOR']: null, Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_TIPOPREVISAO', Param::PARAM_INPUT, isset($params['TIPOPREVISAO']) ? $params['TIPOPREVISAO']: null, Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_CDSUBGRUPPROD', Param::PARAM_INPUT, isset($params['CDSUBGRUPPROD']) ? $params['CDSUBGRUPPROD'] : null, Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_CDPRODINI', Param::PARAM_INPUT, isset($params['CDPRODINI']) ? $params['CDPRODINI'] : null, Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_CDPRODFIN', Param::PARAM_INPUT, isset($params['CDPRODFIN']) ? $params['CDPRODFIN'] : null, Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_CDMARCA', Param::PARAM_INPUT, isset($params['CDMARCA']) ? $params['CDMARCA']: null, Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_DTINICIAL', Param::PARAM_INPUT, isset($params['DTINICIAL']) ? $params['DTINICIAL'] : null, Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_DTFINAL', Param::PARAM_INPUT, isset($params['DTFINAL']) ? $params['DTFINAL'] : null, Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_DTENTREGA', Param::PARAM_INPUT, isset($params['DTENTREGA']) ? $params['DTENTREGA'] : null, Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_CDTIPOCUSTO', Param::PARAM_INPUT, isset($params['CDTIPOCUSTO']) ? $params['CDTIPOCUSTO'] : null, Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_QTDIAESTOQUE', Param::PARAM_INPUT, isset($params['QTDIAESTOQUE']) ? $params['QTDIAESTOQUE'] : null, Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_CDOPERADOR', Param::PARAM_INPUT, $this->environment->getCdOperador(), Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_ROWSAFFECT', Param::PARAM_OUTPUT, $rowsAffect, Param::PARAM_TYPE_STR));
            
            $rowsAffect = $procedure->execute();
            
            return $rowsAffect; 
        }
        catch(\Exception $e){
            throw $e;
        }
    }
    
    public function updateProducts($row) {
        try{
            $sql = "UPDATE ITMAPURPREC
                SET
                    QTACOMP = :P_QTSOLIPROD,
                    QTSOLACOMP = :P_QTSOLIPROD,
                    VRPRECUNIAP  = :P_VRCUSTO,
                    VRPRECECOAP  = :P_VRCUSTO,
                    VRPRECONPIAP  = :P_VRCUSTO
                WHERE
                        CDCENTITMAP = :P_CDFILCENTCMP
                    AND NRSEQITMAP = :P_NRAPURPREC
                    AND CDFORNITMAP = :P_CDFORNECED
                    AND DTENTRAPUT = :P_DTENTRAPUT
                    AND CDFILIAP = :P_CDFILSOLI
                    AND CDPRODITMAP = :P_CDPRODUTO
                    AND CDMARCITMAP = :P_CDMARCA"; 
                    
            $params = [
                "P_QTSOLIPROD"     => $row["QTSOLIPROD"],
                "P_VRCUSTO"        => $row["VRCUSTO"],
                "P_CDFILCENTCMP"   => $row['CDFILLAN'],
                "P_NRAPURPREC"     => $row['NRAPURPREC'],
                "P_CDFORNECED"     => $row['CDFORNECED'],
                "P_DTENTRAPUT"     => $row['DTPROGENTR'],
                "P_CDFILSOLI"      => $row['CDFILSOLI'],
                "P_CDPRODUTO"      => $row['CDPRODUTO'],
                "P_CDMARCA"        => $row['CDMARCA']
            ];
        
            $query = $this->executeQuery($sql, $params);
            
            $this->realizaCommit();
            return  $query;
        } catch (\Exception $e) {
            $this->realizaRollback();  
            
            throw $e;
        }
    }
    
    public function updateProductStats($row) {
       try{
        $sql = "UPDATE ITMAPURPREC
            SET
                IDITMSELAPUR = 'S'
            WHERE
                    CDCENTITMAP = :P_CDFILCENTCMP
                AND NRSEQITMAP = :P_NRAPURPREC
                AND CDFORNITMAP = :P_CDFORNECED
                AND DTENTRAPUT = :P_DTENTRAPUT
                AND CDFILIAP = :P_CDFILSOLI
                AND CDPRODITMAP = :P_CDPRODUTO
                AND CDMARCITMAP = :P_CDMARCA";
                
        $params = ["P_CDFILCENTCMP"   => $row['CDFILLAN'],
            "P_NRAPURPREC"     => $row['NRAPURPREC'],
            "P_CDFORNECED"     => $row['CDFORNECED'],
            "P_DTENTRAPUT"     => $row['DTPROGENTR'],
            "P_CDFILSOLI"      => $row['CDFILSOLI'],
            "P_CDPRODUTO"      => $row['CDPRODUTO'],
            "P_CDMARCA"        => $row['CDMARCA']
        ];
          $std = $this->connection->prepare($sql);

          $std->execute($params);
            
          return $std;
        } catch (\Exception $e) {
            $this->realizaRollback();  
            
            throw $e;
        }
   }
   
      public function efetivarAfProcedure($efetivarAfParams) {
       try{
        $procedure  = new StoredProcedure($this->connection, 'EFETIVAR_AF'); 

        $procedure->addParam(new Param('P_CDOPERADOR',  Param::PARAM_INPUT,   $efetivarAfParams['CDOPERADOR'],  Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_DTAUTOFORN',  Param::PARAM_INPUT,   $efetivarAfParams['DTAUTOFORN'],  Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_CDCENTCMP',  Param::PARAM_INPUT,   $efetivarAfParams['CDFILLAN'],  Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_NRSEQAPUR',  Param::PARAM_INPUT,   $efetivarAfParams['NRAPURPREC'],  Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_CDFILLANC',  Param::PARAM_INPUT,   $efetivarAfParams['CDFILLAN'],  Param::PARAM_TYPE_STR));
        $procedure->execute();
     
        }
        catch(\Exception $e){
            throw $e;
        }
        
    }    
    
      public function retornaAutFor($nrApurPrec, $cdFillan) {
        try{
        $sql = "SELECT CDFILDEST, CDFILLANC, NRAUTOFORN  FROM AUTOFORNE WHERE  CDFILLANC = :P_CDFILCENTCMP    AND NRSEQAPURAF = :P_NRAPURPREC  ";
        $params = [
                'P_NRAPURPREC' => $nrApurPrec,
                'P_CDFILCENTCMP' => $cdFillan
            ];
     
        $std = $this->connection->prepare($sql);

        $std->execute($params);
            
        return $std->fetchAll();
        }
        catch(\Exception $e){
            throw $e;
        }
        
    }
    
        public function procedureFECHA_AUTOFORNE_MOBILE($row) {
         try{
           $P_SEM_ERRO = "";
           $procedure  = new StoredProcedure($this->connection, 'FECHA_AUTOFORNE_MOBILE'); 
           $procedure->addParam(new Param('P_CDFILDEST',  Param::PARAM_INPUT,   $row['CDFILDEST'],  Param::PARAM_TYPE_STR));
           $procedure->addParam(new Param('P_CDFILLANC',  Param::PARAM_INPUT,   $row['CDFILLANC'],  Param::PARAM_TYPE_STR));
           $procedure->addParam(new Param('P_NRAUTOFORN',  Param::PARAM_INPUT,   $row['NRAUTOFORN'],  Param::PARAM_TYPE_STR));
           $procedure->addParam(new Param('P_SEM_ERRO',      Param::PARAM_OUTPUT,  $P_SEM_ERRO,           Param::PARAM_TYPE_STR));
           $P_SEM_ERRO = $procedure->execute();

           return  $P_SEM_ERRO; 
        }
        catch(\Exception $e){
            throw $e;
        }
    }  
    
       public function editarStatusImportAutoForn($row) {
        try{
           $sql = "UPDATE AUTOFORNE
                 SET IDBAIXAAF = NULL
                WHERE CDFILDEST = :CDFILDEST
                  AND CDFILLANC = :CDFILLANC
                  AND NRAUTOFORN = :NRAUTOFORN";
                
        $params = [
            "CDFILDEST"   => $row['CDFILDEST'],
            "CDFILLANC"     => $row['CDFILLANC'],
            "NRAUTOFORN"     => $row['NRAUTOFORN']
       ];
         $std = $this->connection->prepare($sql);

         $std->execute($params);
        
        }
        catch(\Exception $e){
            throw $e;
        }
    }
    
       
    public function getBlockedAF($params) {
        try{
        $sql = "SELECT PARASUPRI.IDBLOQUEAAF FROM PARASUPRI WHERE PARASUPRI.CDFILIAL = :CDFILLANC";
                 
        $params =
            [
                'CDFILLANC' => $params['CDFILLANC']
            ];
    
        $std = $this->connection->prepare($sql);

        $std->execute($params);
            
        
        return $std->fetchAll();
        }
        catch(\Exception $e){
            throw $e;
        }
    }
    
    public function editarStatusImportApurPreco($params) {
           try{
       $sql = "UPDATE APURPRECO  SET IDSITAPUPREC = '2'  WHERE CDFILCENTCMP =  :CDFILCENTCMP    AND NRAPURPREC = :NRAPURPREC";
                
        $params = [
            'NRAPURPREC' => $params['NRAPURPREC'],
            'CDFILCENTCMP' => $params['CDFILLAN']
      ];
       
        $std = $this->connection->prepare($sql);

        $std->execute($params);
        
        }
        catch(\Exception $e){
            throw $e;
        }
    }
    
  
}
