/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_SEGUROBEM                                                */
/* Tabela : SEGUROBEM                                                         */
/*                                                                            */
/* Criao:                                                                   */
/* 04/06/2009 - Frederico Gonalves Moreira da Costa                          */
/*                                                                            */
/******************************************************************************/

CREATE OR REPLACE
TRIGGER DTULTATU_SEGUROBEM
BEFORE INSERT OR UPDATE OR DELETE
ON SEGUROBEM FOR EACH ROW
BEGIN
   IF INSERTING THEN
      :NEW.DTULTATU := SYSDATE;
   END IF;
   IF UPDATING THEN
      IF(NVL(:OLD.NRAPOLICESEGB,0) <> NVL(:NEW.NRAPOLICESEGB,0)) OR
        (NVL(:OLD.DSAPOLICESEGB,0) <> NVL(:NEW.DSAPOLICESEGB,0)) OR
        (NVL(:OLD.CDFORNECED,0) <> NVL(:NEW.CDFORNECED,0)) OR
        (NVL(:OLD.DTINIVIGESEGB,TO_DATE(TRUNC(SYSDATE),'DD/MM/YYYY')) <> NVL(:NEW.DTINIVIGESEGB,TO_DATE(TRUNC(SYSDATE),'DD/MM/YYYY'))) OR
        (NVL(:OLD.DTFINVIGESEGB,TO_DATE(TRUNC(SYSDATE),'DD/MM/YYYY')) <> NVL(:NEW.DTFINVIGESEGB,TO_DATE(TRUNC(SYSDATE),'DD/MM/YYYY'))) OR
        (NVL(:OLD.VRBEMSEGURO,0) <> NVL(:NEW.VRBEMSEGURO,0)) OR
        (NVL(:OLD.VRFRANQUIASEGB,0) <> NVL(:NEW.VRFRANQUIASEGB,0)) OR
        (NVL(:OLD.VRPREMIOSEGUB,0) <> NVL(:NEW.VRPREMIOSEGUB,0)) OR
        (NVL(:OLD.NRPARCELASEGB,0) <> NVL(:NEW.NRPARCELASEGB,0)) OR
        (NVL(:OLD.NMCORRETORSEGB,0) <> NVL(:NEW.NMCORRETORSEGB,0)) OR
        (NVL(:OLD.NMBENEFICSEGB,0) <> NVL(:NEW.NMBENEFICSEGB,0)) OR
        (NVL(:OLD.DSCOBERTUSEGB,0) <> NVL(:NEW.DSCOBERTUSEGB,0)) THEN
         :NEW.DTULTATU := SYSDATE;
      END IF;
   END IF;
   IF DELETING THEN
      INSERT INTO DELETECACHE (NMTABLECACHE,CDFILICACHE,DSKEYCACHE,DTULTATUCACH)
      VALUES ('SEGUROBEM','','CDEMPRESA='||:OLD.CDEMPRESA||';CDBEMATIVO='||:OLD.CDBEMATIVO||';NRSEQSEGBEM='||:OLD.NRSEQSEGBEM||';',SYSDATE);
   END IF;
END;
/
ALTER TABLE SEGUROBEM MODIFY DTULTATU DEFAULT SYSDATE
/

-- VERSAO --
BEGIN ATUVEROBJ('DTULTATU_SEGUROBEM','5.05.119'); END;
/

